<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width">
  <meta name="nodejs.org:node-version" content="v18.7.0">
  <title>Timers | Node.js v18.7.0 Documentation</title>
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato:400,700,400italic&display=fallback">
  <link rel="stylesheet" href="assets/style.css">
  <link rel="stylesheet" href="assets/hljs.css">
  <link rel="canonical" href="https://nodejs.org/api/timers.html">
  <script async defer src="assets/api.js" type="text/javascript"></script>
  <style>@media(max-width:326px){.with-13-chars>.js-flavor-selector{float:none;margin:0 0 1em auto;}}@media(max-width:342px){.with-15-chars>.js-flavor-selector{float:none;margin:0 0 1em auto;}}@media(max-width:334px){.with-14-chars>.js-flavor-selector{float:none;margin:0 0 1em auto;}}</style>
</head>
<body class="alt apidoc" id="api-section-timers">
  <div id="content" class="clearfix">
    <div id="column2" class="interior">
      <div id="intro" class="interior">
        <a href="/" title="Go back to the home page">
          Node.js
        </a>
      </div>
      <ul>
<li><a href="documentation.html" class="nav-documentation">About this documentation</a></li>
<li><a href="synopsis.html" class="nav-synopsis">Usage and example</a></li>
</ul>
<hr class="line">
<ul>
<li><a href="assert.html" class="nav-assert">Assertion testing</a></li>
<li><a href="async_context.html" class="nav-async_context">Asynchronous context tracking</a></li>
<li><a href="async_hooks.html" class="nav-async_hooks">Async hooks</a></li>
<li><a href="buffer.html" class="nav-buffer">Buffer</a></li>
<li><a href="addons.html" class="nav-addons">C++ addons</a></li>
<li><a href="n-api.html" class="nav-n-api">C/C++ addons with Node-API</a></li>
<li><a href="embedding.html" class="nav-embedding">C++ embedder API</a></li>
<li><a href="child_process.html" class="nav-child_process">Child processes</a></li>
<li><a href="cluster.html" class="nav-cluster">Cluster</a></li>
<li><a href="cli.html" class="nav-cli">Command-line options</a></li>
<li><a href="console.html" class="nav-console">Console</a></li>
<li><a href="corepack.html" class="nav-corepack">Corepack</a></li>
<li><a href="crypto.html" class="nav-crypto">Crypto</a></li>
<li><a href="debugger.html" class="nav-debugger">Debugger</a></li>
<li><a href="deprecations.html" class="nav-deprecations">Deprecated APIs</a></li>
<li><a href="diagnostics_channel.html" class="nav-diagnostics_channel">Diagnostics Channel</a></li>
<li><a href="dns.html" class="nav-dns">DNS</a></li>
<li><a href="domain.html" class="nav-domain">Domain</a></li>
<li><a href="errors.html" class="nav-errors">Errors</a></li>
<li><a href="events.html" class="nav-events">Events</a></li>
<li><a href="fs.html" class="nav-fs">File system</a></li>
<li><a href="globals.html" class="nav-globals">Globals</a></li>
<li><a href="http.html" class="nav-http">HTTP</a></li>
<li><a href="http2.html" class="nav-http2">HTTP/2</a></li>
<li><a href="https.html" class="nav-https">HTTPS</a></li>
<li><a href="inspector.html" class="nav-inspector">Inspector</a></li>
<li><a href="intl.html" class="nav-intl">Internationalization</a></li>
<li><a href="modules.html" class="nav-modules">Modules: CommonJS modules</a></li>
<li><a href="esm.html" class="nav-esm">Modules: ECMAScript modules</a></li>
<li><a href="module.html" class="nav-module">Modules: <code>node:module</code> API</a></li>
<li><a href="packages.html" class="nav-packages">Modules: Packages</a></li>
<li><a href="net.html" class="nav-net">Net</a></li>
<li><a href="os.html" class="nav-os">OS</a></li>
<li><a href="path.html" class="nav-path">Path</a></li>
<li><a href="perf_hooks.html" class="nav-perf_hooks">Performance hooks</a></li>
<li><a href="policy.html" class="nav-policy">Policies</a></li>
<li><a href="process.html" class="nav-process">Process</a></li>
<li><a href="punycode.html" class="nav-punycode">Punycode</a></li>
<li><a href="querystring.html" class="nav-querystring">Query strings</a></li>
<li><a href="readline.html" class="nav-readline">Readline</a></li>
<li><a href="repl.html" class="nav-repl">REPL</a></li>
<li><a href="report.html" class="nav-report">Report</a></li>
<li><a href="stream.html" class="nav-stream">Stream</a></li>
<li><a href="string_decoder.html" class="nav-string_decoder">String decoder</a></li>
<li><a href="test.html" class="nav-test">Test runner</a></li>
<li><a href="timers.html" class="nav-timers active">Timers</a></li>
<li><a href="tls.html" class="nav-tls">TLS/SSL</a></li>
<li><a href="tracing.html" class="nav-tracing">Trace events</a></li>
<li><a href="tty.html" class="nav-tty">TTY</a></li>
<li><a href="dgram.html" class="nav-dgram">UDP/datagram</a></li>
<li><a href="url.html" class="nav-url">URL</a></li>
<li><a href="util.html" class="nav-util">Utilities</a></li>
<li><a href="v8.html" class="nav-v8">V8</a></li>
<li><a href="vm.html" class="nav-vm">VM</a></li>
<li><a href="wasi.html" class="nav-wasi">WASI</a></li>
<li><a href="webcrypto.html" class="nav-webcrypto">Web Crypto API</a></li>
<li><a href="webstreams.html" class="nav-webstreams">Web Streams API</a></li>
<li><a href="worker_threads.html" class="nav-worker_threads">Worker threads</a></li>
<li><a href="zlib.html" class="nav-zlib">Zlib</a></li>
</ul>
<hr class="line">
<ul>
<li><a href="https://github.com/nodejs/node" class="nav-https-github-com-nodejs-node">Code repository and issue tracker</a></li>
</ul>
    </div>

    <div id="column1" data-id="timers" class="interior">
      <header class="header">
        <div class="header-container">
          <h1>Node.js v18.7.0 documentation</h1>
          <button class="theme-toggle-btn" id="theme-toggle-btn" title="Toggle dark mode/light mode" aria-label="Toggle dark mode/light mode" hidden>
            <svg xmlns="http://www.w3.org/2000/svg" class="icon dark-icon" height="24" width="24">
              <path fill="none" d="M0 0h24v24H0z" />
              <path d="M11.1 12.08c-2.33-4.51-.5-8.48.53-10.07C6.27 2.2 1.98 6.59 1.98 12c0 .14.02.28.02.42.62-.27 1.29-.42 2-.42 1.66 0 3.18.83 4.1 2.15A4.01 4.01 0 0111 18c0 1.52-.87 2.83-2.12 3.51.98.32 2.03.5 3.11.5 3.5 0 6.58-1.8 8.37-4.52-2.36.23-6.98-.97-9.26-5.41z"/>
              <path d="M7 16h-.18C6.4 14.84 5.3 14 4 14c-1.66 0-3 1.34-3 3s1.34 3 3 3h3c1.1 0 2-.9 2-2s-.9-2-2-2z"/>
            </svg>
            <svg xmlns="http://www.w3.org/2000/svg" class="icon light-icon" height="24" width="24">
              <path d="M0 0h24v24H0z" fill="none" />
              <path d="M6.76 4.84l-1.8-1.79-1.41 1.41 1.79 1.79 1.42-1.41zM4 10.5H1v2h3v-2zm9-9.95h-2V3.5h2V.55zm7.45 3.91l-1.41-1.41-1.79 1.79 1.41 1.41 1.79-1.79zm-3.21 13.7l1.79 1.8 1.41-1.41-1.8-1.79-1.4 1.4zM20 10.5v2h3v-2h-3zm-8-5c-3.31 0-6 2.69-6 6s2.69 6 6 6 6-2.69 6-6-2.69-6-6-6zm-1 16.95h2V19.5h-2v2.95zm-7.45-3.91l1.41 1.41 1.79-1.8-1.41-1.41-1.79 1.8z"/>
            </svg>
          </button>
        </div>
        <div id="gtoc">
          <ul>
            <li class="pinned-header">Node.js v18.7.0</li>
            
    <li class="picker-header">
      <a href="#">
        <span class="collapsed-arrow">&#x25ba;</span><span class="expanded-arrow">&#x25bc;</span>
        Table of contents
      </a>

      <div class="picker"><div class="toc"><ul>
<li><span class="stability_2"><a href="#timers">Timers</a></span>
<ul>
<li><a href="#class-immediate">Class: <code>Immediate</code></a>
<ul>
<li><a href="#immediatehasref"><code>immediate.hasRef()</code></a></li>
<li><a href="#immediateref"><code>immediate.ref()</code></a></li>
<li><a href="#immediateunref"><code>immediate.unref()</code></a></li>
</ul>
</li>
<li><a href="#class-timeout">Class: <code>Timeout</code></a>
<ul>
<li><span class="stability_3"><a href="#timeoutclose"><code>timeout.close()</code></a></span></li>
<li><a href="#timeouthasref"><code>timeout.hasRef()</code></a></li>
<li><a href="#timeoutref"><code>timeout.ref()</code></a></li>
<li><a href="#timeoutrefresh"><code>timeout.refresh()</code></a></li>
<li><a href="#timeoutunref"><code>timeout.unref()</code></a></li>
<li><a href="#timeoutsymboltoprimitive"><code>timeout[Symbol.toPrimitive]()</code></a></li>
</ul>
</li>
<li><a href="#scheduling-timers">Scheduling timers</a>
<ul>
<li><a href="#setimmediatecallback-args"><code>setImmediate(callback[, ...args])</code></a></li>
<li><a href="#setintervalcallback-delay-args"><code>setInterval(callback[, delay[, ...args]])</code></a></li>
<li><a href="#settimeoutcallback-delay-args"><code>setTimeout(callback[, delay[, ...args]])</code></a></li>
</ul>
</li>
<li><a href="#cancelling-timers">Cancelling timers</a>
<ul>
<li><a href="#clearimmediateimmediate"><code>clearImmediate(immediate)</code></a></li>
<li><a href="#clearintervaltimeout"><code>clearInterval(timeout)</code></a></li>
<li><a href="#cleartimeouttimeout"><code>clearTimeout(timeout)</code></a></li>
</ul>
</li>
<li><a href="#timers-promises-api">Timers Promises API</a>
<ul>
<li><a href="#timerspromisessettimeoutdelay-value-options"><code>timersPromises.setTimeout([delay[, value[, options]]])</code></a></li>
<li><a href="#timerspromisessetimmediatevalue-options"><code>timersPromises.setImmediate([value[, options]])</code></a></li>
<li><a href="#timerspromisessetintervaldelay-value-options"><code>timersPromises.setInterval([delay[, value[, options]]])</code></a></li>
<li><span class="stability_1"><a href="#timerspromisesschedulerwaitdelay-options"><code>timersPromises.scheduler.wait(delay[, options])</code></a></span></li>
<li><span class="stability_1"><a href="#timerspromisesscheduleryield"><code>timersPromises.scheduler.yield()</code></a></span></li>
</ul>
</li>
</ul>
</li>
</ul></div></div>
    </li>
  
            
    <li class="picker-header">
      <a href="#">
        <span class="collapsed-arrow">&#x25ba;</span><span class="expanded-arrow">&#x25bc;</span>
        Index
      </a>

      <div class="picker"><ul>
<li><a href="documentation.html" class="nav-documentation">About this documentation</a></li>
<li><a href="synopsis.html" class="nav-synopsis">Usage and example</a></li>

      <li>
        <a href="index.html">Index</a>
      </li>
    </ul>
  
<hr class="line">
<ul>
<li><a href="assert.html" class="nav-assert">Assertion testing</a></li>
<li><a href="async_context.html" class="nav-async_context">Asynchronous context tracking</a></li>
<li><a href="async_hooks.html" class="nav-async_hooks">Async hooks</a></li>
<li><a href="buffer.html" class="nav-buffer">Buffer</a></li>
<li><a href="addons.html" class="nav-addons">C++ addons</a></li>
<li><a href="n-api.html" class="nav-n-api">C/C++ addons with Node-API</a></li>
<li><a href="embedding.html" class="nav-embedding">C++ embedder API</a></li>
<li><a href="child_process.html" class="nav-child_process">Child processes</a></li>
<li><a href="cluster.html" class="nav-cluster">Cluster</a></li>
<li><a href="cli.html" class="nav-cli">Command-line options</a></li>
<li><a href="console.html" class="nav-console">Console</a></li>
<li><a href="corepack.html" class="nav-corepack">Corepack</a></li>
<li><a href="crypto.html" class="nav-crypto">Crypto</a></li>
<li><a href="debugger.html" class="nav-debugger">Debugger</a></li>
<li><a href="deprecations.html" class="nav-deprecations">Deprecated APIs</a></li>
<li><a href="diagnostics_channel.html" class="nav-diagnostics_channel">Diagnostics Channel</a></li>
<li><a href="dns.html" class="nav-dns">DNS</a></li>
<li><a href="domain.html" class="nav-domain">Domain</a></li>
<li><a href="errors.html" class="nav-errors">Errors</a></li>
<li><a href="events.html" class="nav-events">Events</a></li>
<li><a href="fs.html" class="nav-fs">File system</a></li>
<li><a href="globals.html" class="nav-globals">Globals</a></li>
<li><a href="http.html" class="nav-http">HTTP</a></li>
<li><a href="http2.html" class="nav-http2">HTTP/2</a></li>
<li><a href="https.html" class="nav-https">HTTPS</a></li>
<li><a href="inspector.html" class="nav-inspector">Inspector</a></li>
<li><a href="intl.html" class="nav-intl">Internationalization</a></li>
<li><a href="modules.html" class="nav-modules">Modules: CommonJS modules</a></li>
<li><a href="esm.html" class="nav-esm">Modules: ECMAScript modules</a></li>
<li><a href="module.html" class="nav-module">Modules: <code>node:module</code> API</a></li>
<li><a href="packages.html" class="nav-packages">Modules: Packages</a></li>
<li><a href="net.html" class="nav-net">Net</a></li>
<li><a href="os.html" class="nav-os">OS</a></li>
<li><a href="path.html" class="nav-path">Path</a></li>
<li><a href="perf_hooks.html" class="nav-perf_hooks">Performance hooks</a></li>
<li><a href="policy.html" class="nav-policy">Policies</a></li>
<li><a href="process.html" class="nav-process">Process</a></li>
<li><a href="punycode.html" class="nav-punycode">Punycode</a></li>
<li><a href="querystring.html" class="nav-querystring">Query strings</a></li>
<li><a href="readline.html" class="nav-readline">Readline</a></li>
<li><a href="repl.html" class="nav-repl">REPL</a></li>
<li><a href="report.html" class="nav-report">Report</a></li>
<li><a href="stream.html" class="nav-stream">Stream</a></li>
<li><a href="string_decoder.html" class="nav-string_decoder">String decoder</a></li>
<li><a href="test.html" class="nav-test">Test runner</a></li>
<li><a href="timers.html" class="nav-timers active">Timers</a></li>
<li><a href="tls.html" class="nav-tls">TLS/SSL</a></li>
<li><a href="tracing.html" class="nav-tracing">Trace events</a></li>
<li><a href="tty.html" class="nav-tty">TTY</a></li>
<li><a href="dgram.html" class="nav-dgram">UDP/datagram</a></li>
<li><a href="url.html" class="nav-url">URL</a></li>
<li><a href="util.html" class="nav-util">Utilities</a></li>
<li><a href="v8.html" class="nav-v8">V8</a></li>
<li><a href="vm.html" class="nav-vm">VM</a></li>
<li><a href="wasi.html" class="nav-wasi">WASI</a></li>
<li><a href="webcrypto.html" class="nav-webcrypto">Web Crypto API</a></li>
<li><a href="webstreams.html" class="nav-webstreams">Web Streams API</a></li>
<li><a href="worker_threads.html" class="nav-worker_threads">Worker threads</a></li>
<li><a href="zlib.html" class="nav-zlib">Zlib</a></li>
</ul>
<hr class="line">
<ul>
<li><a href="https://github.com/nodejs/node" class="nav-https-github-com-nodejs-node">Code repository and issue tracker</a></li>
</ul></div>
    </li>
  
            
    <li class="picker-header">
      <a href="#">
        <span class="collapsed-arrow">&#x25ba;</span><span class="expanded-arrow">&#x25bc;</span>
        Other versions
      </a>
      <div class="picker"><ol id="alt-docs"><li><a href="https://nodejs.org/docs/latest-v18.x/api/timers.html">18.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v17.x/api/timers.html">17.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v16.x/api/timers.html">16.x <b>LTS</b></a></li>
<li><a href="https://nodejs.org/docs/latest-v15.x/api/timers.html">15.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v14.x/api/timers.html">14.x <b>LTS</b></a></li>
<li><a href="https://nodejs.org/docs/latest-v13.x/api/timers.html">13.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v12.x/api/timers.html">12.x <b>LTS</b></a></li>
<li><a href="https://nodejs.org/docs/latest-v11.x/api/timers.html">11.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v10.x/api/timers.html">10.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v9.x/api/timers.html">9.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v8.x/api/timers.html">8.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v7.x/api/timers.html">7.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v6.x/api/timers.html">6.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v5.x/api/timers.html">5.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v4.x/api/timers.html">4.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v0.12.x/api/timers.html">0.12.x</a></li>
<li><a href="https://nodejs.org/docs/latest-v0.10.x/api/timers.html">0.10.x</a></li></ol></div>
    </li>
  
            <li class="picker-header">
              <a href="#">
                <span class="collapsed-arrow">&#x25ba;</span><span class="expanded-arrow">&#x25bc;</span>
                Options
              </a>
        
              <div class="picker">
                <ul>
                  <li>
                    <a href="all.html">View on single page</a>
                  </li>
                  <li>
                    <a href="timers.json">View as JSON</a>
                  </li>
                  <li class="edit_on_github"><a href="https://github.com/nodejs/node/edit/main/doc/api/timers.md">Edit on GitHub</a></li>    
                </ul>
              </div>
            </li>
          </ul>
        </div>
        <hr>
      </header>

      <details id="toc" open><summary>Table of contents</summary><ul>
<li><span class="stability_2"><a href="#timers">Timers</a></span>
<ul>
<li><a href="#class-immediate">Class: <code>Immediate</code></a>
<ul>
<li><a href="#immediatehasref"><code>immediate.hasRef()</code></a></li>
<li><a href="#immediateref"><code>immediate.ref()</code></a></li>
<li><a href="#immediateunref"><code>immediate.unref()</code></a></li>
</ul>
</li>
<li><a href="#class-timeout">Class: <code>Timeout</code></a>
<ul>
<li><span class="stability_3"><a href="#timeoutclose"><code>timeout.close()</code></a></span></li>
<li><a href="#timeouthasref"><code>timeout.hasRef()</code></a></li>
<li><a href="#timeoutref"><code>timeout.ref()</code></a></li>
<li><a href="#timeoutrefresh"><code>timeout.refresh()</code></a></li>
<li><a href="#timeoutunref"><code>timeout.unref()</code></a></li>
<li><a href="#timeoutsymboltoprimitive"><code>timeout[Symbol.toPrimitive]()</code></a></li>
</ul>
</li>
<li><a href="#scheduling-timers">Scheduling timers</a>
<ul>
<li><a href="#setimmediatecallback-args"><code>setImmediate(callback[, ...args])</code></a></li>
<li><a href="#setintervalcallback-delay-args"><code>setInterval(callback[, delay[, ...args]])</code></a></li>
<li><a href="#settimeoutcallback-delay-args"><code>setTimeout(callback[, delay[, ...args]])</code></a></li>
</ul>
</li>
<li><a href="#cancelling-timers">Cancelling timers</a>
<ul>
<li><a href="#clearimmediateimmediate"><code>clearImmediate(immediate)</code></a></li>
<li><a href="#clearintervaltimeout"><code>clearInterval(timeout)</code></a></li>
<li><a href="#cleartimeouttimeout"><code>clearTimeout(timeout)</code></a></li>
</ul>
</li>
<li><a href="#timers-promises-api">Timers Promises API</a>
<ul>
<li><a href="#timerspromisessettimeoutdelay-value-options"><code>timersPromises.setTimeout([delay[, value[, options]]])</code></a></li>
<li><a href="#timerspromisessetimmediatevalue-options"><code>timersPromises.setImmediate([value[, options]])</code></a></li>
<li><a href="#timerspromisessetintervaldelay-value-options"><code>timersPromises.setInterval([delay[, value[, options]]])</code></a></li>
<li><span class="stability_1"><a href="#timerspromisesschedulerwaitdelay-options"><code>timersPromises.scheduler.wait(delay[, options])</code></a></span></li>
<li><span class="stability_1"><a href="#timerspromisesscheduleryield"><code>timersPromises.scheduler.yield()</code></a></span></li>
</ul>
</li>
</ul>
</li>
</ul></details>

      <div id="apicontent">
        <h2>Timers<span><a class="mark" href="#timers" id="timers">#</a></span><a aria-hidden="true" class="legacy" id="timers_timers"></a></h2>

<p></p><div class="api_stability api_stability_2"><a href="documentation.html#stability-index">Stability: 2</a> - Stable</div><p></p>
<p><strong>Source Code:</strong> <a href="https://github.com/nodejs/node/blob/v18.7.0/lib/timers.js">lib/timers.js</a></p>
<p>The <code>timer</code> module exposes a global API for scheduling functions to
be called at some future period of time. Because the timer functions are
globals, there is no need to call <code>require('node:timers')</code> to use the API.</p>
<p>The timer functions within Node.js implement a similar API as the timers API
provided by Web Browsers but use a different internal implementation that is
built around the Node.js <a href="https://nodejs.org/en/docs/guides/event-loop-timers-and-nexttick/#setimmediate-vs-settimeout">Event Loop</a>.</p>
<section><h3>Class: <code>Immediate</code><span><a class="mark" href="#class-immediate" id="class-immediate">#</a></span><a aria-hidden="true" class="legacy" id="timers_class_immediate"></a></h3>
<p>This object is created internally and is returned from <a href="#setimmediatecallback-args"><code>setImmediate()</code></a>. It
can be passed to <a href="#clearimmediateimmediate"><code>clearImmediate()</code></a> in order to cancel the scheduled
actions.</p>
<p>By default, when an immediate is scheduled, the Node.js event loop will continue
running as long as the immediate is active. The <code>Immediate</code> object returned by
<a href="#setimmediatecallback-args"><code>setImmediate()</code></a> exports both <code>immediate.ref()</code> and <code>immediate.unref()</code>
functions that can be used to control this default behavior.</p>
<h4><code>immediate.hasRef()</code><span><a class="mark" href="#immediatehasref" id="immediatehasref">#</a></span><a aria-hidden="true" class="legacy" id="timers_immediate_hasref"></a></h4>
<div class="api_metadata">
<span>Added in: v11.0.0</span>
</div>
<ul>
<li>Returns: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Boolean_type" class="type">&#x3C;boolean></a></li>
</ul>
<p>If true, the <code>Immediate</code> object will keep the Node.js event loop active.</p>
<h4><code>immediate.ref()</code><span><a class="mark" href="#immediateref" id="immediateref">#</a></span><a aria-hidden="true" class="legacy" id="timers_immediate_ref"></a></h4>
<div class="api_metadata">
<span>Added in: v9.7.0</span>
</div>
<ul>
<li>Returns: <a href="timers.html#class-immediate" class="type">&#x3C;Immediate></a> a reference to <code>immediate</code></li>
</ul>
<p>When called, requests that the Node.js event loop <em>not</em> exit so long as the
<code>Immediate</code> is active. Calling <code>immediate.ref()</code> multiple times will have no
effect.</p>
<p>By default, all <code>Immediate</code> objects are "ref'ed", making it normally unnecessary
to call <code>immediate.ref()</code> unless <code>immediate.unref()</code> had been called previously.</p>
<h4><code>immediate.unref()</code><span><a class="mark" href="#immediateunref" id="immediateunref">#</a></span><a aria-hidden="true" class="legacy" id="timers_immediate_unref"></a></h4>
<div class="api_metadata">
<span>Added in: v9.7.0</span>
</div>
<ul>
<li>Returns: <a href="timers.html#class-immediate" class="type">&#x3C;Immediate></a> a reference to <code>immediate</code></li>
</ul>
<p>When called, the active <code>Immediate</code> object will not require the Node.js event
loop to remain active. If there is no other activity keeping the event loop
running, the process may exit before the <code>Immediate</code> object's callback is
invoked. Calling <code>immediate.unref()</code> multiple times will have no effect.</p>
</section><section><h3>Class: <code>Timeout</code><span><a class="mark" href="#class-timeout" id="class-timeout">#</a></span><a aria-hidden="true" class="legacy" id="timers_class_timeout"></a></h3>
<p>This object is created internally and is returned from <a href="#settimeoutcallback-delay-args"><code>setTimeout()</code></a> and
<a href="#setintervalcallback-delay-args"><code>setInterval()</code></a>. It can be passed to either <a href="#cleartimeouttimeout"><code>clearTimeout()</code></a> or
<a href="#clearintervaltimeout"><code>clearInterval()</code></a> in order to cancel the scheduled actions.</p>
<p>By default, when a timer is scheduled using either <a href="#settimeoutcallback-delay-args"><code>setTimeout()</code></a> or
<a href="#setintervalcallback-delay-args"><code>setInterval()</code></a>, the Node.js event loop will continue running as long as the
timer is active. Each of the <code>Timeout</code> objects returned by these functions
export both <code>timeout.ref()</code> and <code>timeout.unref()</code> functions that can be used to
control this default behavior.</p>
<h4><code>timeout.close()</code><span><a class="mark" href="#timeoutclose" id="timeoutclose">#</a></span><a aria-hidden="true" class="legacy" id="timers_timeout_close"></a></h4>
<div class="api_metadata">
<span>Added in: v0.9.1</span>
</div>
<p></p><div class="api_stability api_stability_3"><a href="documentation.html#stability-index">Stability: 3</a> - Legacy: Use <a href="#cleartimeouttimeout"><code>clearTimeout()</code></a> instead.</div><p></p>
<ul>
<li>Returns: <a href="timers.html#class-timeout" class="type">&#x3C;Timeout></a> a reference to <code>timeout</code></li>
</ul>
<p>Cancels the timeout.</p>
<h4><code>timeout.hasRef()</code><span><a class="mark" href="#timeouthasref" id="timeouthasref">#</a></span><a aria-hidden="true" class="legacy" id="timers_timeout_hasref"></a></h4>
<div class="api_metadata">
<span>Added in: v11.0.0</span>
</div>
<ul>
<li>Returns: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Boolean_type" class="type">&#x3C;boolean></a></li>
</ul>
<p>If true, the <code>Timeout</code> object will keep the Node.js event loop active.</p>
<h4><code>timeout.ref()</code><span><a class="mark" href="#timeoutref" id="timeoutref">#</a></span><a aria-hidden="true" class="legacy" id="timers_timeout_ref"></a></h4>
<div class="api_metadata">
<span>Added in: v0.9.1</span>
</div>
<ul>
<li>Returns: <a href="timers.html#class-timeout" class="type">&#x3C;Timeout></a> a reference to <code>timeout</code></li>
</ul>
<p>When called, requests that the Node.js event loop <em>not</em> exit so long as the
<code>Timeout</code> is active. Calling <code>timeout.ref()</code> multiple times will have no effect.</p>
<p>By default, all <code>Timeout</code> objects are "ref'ed", making it normally unnecessary
to call <code>timeout.ref()</code> unless <code>timeout.unref()</code> had been called previously.</p>
<h4><code>timeout.refresh()</code><span><a class="mark" href="#timeoutrefresh" id="timeoutrefresh">#</a></span><a aria-hidden="true" class="legacy" id="timers_timeout_refresh"></a></h4>
<div class="api_metadata">
<span>Added in: v10.2.0</span>
</div>
<ul>
<li>Returns: <a href="timers.html#class-timeout" class="type">&#x3C;Timeout></a> a reference to <code>timeout</code></li>
</ul>
<p>Sets the timer's start time to the current time, and reschedules the timer to
call its callback at the previously specified duration adjusted to the current
time. This is useful for refreshing a timer without allocating a new
JavaScript object.</p>
<p>Using this on a timer that has already called its callback will reactivate the
timer.</p>
<h4><code>timeout.unref()</code><span><a class="mark" href="#timeoutunref" id="timeoutunref">#</a></span><a aria-hidden="true" class="legacy" id="timers_timeout_unref"></a></h4>
<div class="api_metadata">
<span>Added in: v0.9.1</span>
</div>
<ul>
<li>Returns: <a href="timers.html#class-timeout" class="type">&#x3C;Timeout></a> a reference to <code>timeout</code></li>
</ul>
<p>When called, the active <code>Timeout</code> object will not require the Node.js event loop
to remain active. If there is no other activity keeping the event loop running,
the process may exit before the <code>Timeout</code> object's callback is invoked. Calling
<code>timeout.unref()</code> multiple times will have no effect.</p>
<h4><code>timeout[Symbol.toPrimitive]()</code><span><a class="mark" href="#timeoutsymboltoprimitive" id="timeoutsymboltoprimitive">#</a></span><a aria-hidden="true" class="legacy" id="timers_timeout_symbol_toprimitive"></a></h4>
<div class="api_metadata">
<span>Added in: v14.9.0, v12.19.0</span>
</div>
<ul>
<li>Returns: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Number_type" class="type">&#x3C;integer></a> a number that can be used to reference this <code>timeout</code></li>
</ul>
<p>Coerce a <code>Timeout</code> to a primitive. The primitive can be used to
clear the <code>Timeout</code>. The primitive can only be used in the
same thread where the timeout was created. Therefore, to use it
across <a href="worker_threads.html"><code>worker_threads</code></a> it must first be passed to the correct
thread. This allows enhanced compatibility with browser
<code>setTimeout()</code> and <code>setInterval()</code> implementations.</p>
</section><section><h3>Scheduling timers<span><a class="mark" href="#scheduling-timers" id="scheduling-timers">#</a></span><a aria-hidden="true" class="legacy" id="timers_scheduling_timers"></a></h3>
<p>A timer in Node.js is an internal construct that calls a given function after
a certain period of time. When a timer's function is called varies depending on
which method was used to create the timer and what other work the Node.js
event loop is doing.</p>
<h4><code>setImmediate(callback[, ...args])</code><span><a class="mark" href="#setimmediatecallback-args" id="setimmediatecallback-args">#</a></span><a aria-hidden="true" class="legacy" id="timers_setimmediate_callback_args"></a></h4>
<div class="api_metadata">
<details class="changelog"><summary>History</summary>
<table>
<tbody><tr><th>Version</th><th>Changes</th></tr>
<tr><td>v18.0.0</td>
<td><p>Passing an invalid callback to the <code>callback</code> argument now throws <code>ERR_INVALID_ARG_TYPE</code> instead of <code>ERR_INVALID_CALLBACK</code>.</p></td></tr>
<tr><td>v0.9.1</td>
<td><p><span>Added in: v0.9.1</span></p></td></tr>
</tbody></table>
</details>
</div>
<ul>
<li><code>callback</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function" class="type">&#x3C;Function></a> The function to call at the end of this turn of
the Node.js <a href="https://nodejs.org/en/docs/guides/event-loop-timers-and-nexttick/#setimmediate-vs-settimeout">Event Loop</a></li>
<li><code>...args</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Data_types" class="type">&#x3C;any></a> Optional arguments to pass when the <code>callback</code> is called.</li>
<li>Returns: <a href="timers.html#class-immediate" class="type">&#x3C;Immediate></a> for use with <a href="#clearimmediateimmediate"><code>clearImmediate()</code></a></li>
</ul>
<p>Schedules the "immediate" execution of the <code>callback</code> after I/O events'
callbacks.</p>
<p>When multiple calls to <code>setImmediate()</code> are made, the <code>callback</code> functions are
queued for execution in the order in which they are created. The entire callback
queue is processed every event loop iteration. If an immediate timer is queued
from inside an executing callback, that timer will not be triggered until the
next event loop iteration.</p>
<p>If <code>callback</code> is not a function, a <a href="errors.html#class-typeerror"><code>TypeError</code></a> will be thrown.</p>
<p>This method has a custom variant for promises that is available using
<a href="#timerspromisessetimmediatevalue-options"><code>timersPromises.setImmediate()</code></a>.</p>
<h4><code>setInterval(callback[, delay[, ...args]])</code><span><a class="mark" href="#setintervalcallback-delay-args" id="setintervalcallback-delay-args">#</a></span><a aria-hidden="true" class="legacy" id="timers_setinterval_callback_delay_args"></a></h4>
<div class="api_metadata">
<details class="changelog"><summary>History</summary>
<table>
<tbody><tr><th>Version</th><th>Changes</th></tr>
<tr><td>v18.0.0</td>
<td><p>Passing an invalid callback to the <code>callback</code> argument now throws <code>ERR_INVALID_ARG_TYPE</code> instead of <code>ERR_INVALID_CALLBACK</code>.</p></td></tr>
<tr><td>v0.0.1</td>
<td><p><span>Added in: v0.0.1</span></p></td></tr>
</tbody></table>
</details>
</div>
<ul>
<li><code>callback</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function" class="type">&#x3C;Function></a> The function to call when the timer elapses.</li>
<li><code>delay</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Number_type" class="type">&#x3C;number></a> The number of milliseconds to wait before calling the
<code>callback</code>. <strong>Default:</strong> <code>1</code>.</li>
<li><code>...args</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Data_types" class="type">&#x3C;any></a> Optional arguments to pass when the <code>callback</code> is called.</li>
<li>Returns: <a href="timers.html#class-timeout" class="type">&#x3C;Timeout></a> for use with <a href="#clearintervaltimeout"><code>clearInterval()</code></a></li>
</ul>
<p>Schedules repeated execution of <code>callback</code> every <code>delay</code> milliseconds.</p>
<p>When <code>delay</code> is larger than <code>2147483647</code> or less than <code>1</code>, the <code>delay</code> will be
set to <code>1</code>. Non-integer delays are truncated to an integer.</p>
<p>If <code>callback</code> is not a function, a <a href="errors.html#class-typeerror"><code>TypeError</code></a> will be thrown.</p>
<p>This method has a custom variant for promises that is available using
<a href="#timerspromisessetintervaldelay-value-options"><code>timersPromises.setInterval()</code></a>.</p>
<h4><code>setTimeout(callback[, delay[, ...args]])</code><span><a class="mark" href="#settimeoutcallback-delay-args" id="settimeoutcallback-delay-args">#</a></span><a aria-hidden="true" class="legacy" id="timers_settimeout_callback_delay_args"></a></h4>
<div class="api_metadata">
<details class="changelog"><summary>History</summary>
<table>
<tbody><tr><th>Version</th><th>Changes</th></tr>
<tr><td>v18.0.0</td>
<td><p>Passing an invalid callback to the <code>callback</code> argument now throws <code>ERR_INVALID_ARG_TYPE</code> instead of <code>ERR_INVALID_CALLBACK</code>.</p></td></tr>
<tr><td>v0.0.1</td>
<td><p><span>Added in: v0.0.1</span></p></td></tr>
</tbody></table>
</details>
</div>
<ul>
<li><code>callback</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function" class="type">&#x3C;Function></a> The function to call when the timer elapses.</li>
<li><code>delay</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Number_type" class="type">&#x3C;number></a> The number of milliseconds to wait before calling the
<code>callback</code>. <strong>Default:</strong> <code>1</code>.</li>
<li><code>...args</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Data_types" class="type">&#x3C;any></a> Optional arguments to pass when the <code>callback</code> is called.</li>
<li>Returns: <a href="timers.html#class-timeout" class="type">&#x3C;Timeout></a> for use with <a href="#cleartimeouttimeout"><code>clearTimeout()</code></a></li>
</ul>
<p>Schedules execution of a one-time <code>callback</code> after <code>delay</code> milliseconds.</p>
<p>The <code>callback</code> will likely not be invoked in precisely <code>delay</code> milliseconds.
Node.js makes no guarantees about the exact timing of when callbacks will fire,
nor of their ordering. The callback will be called as close as possible to the
time specified.</p>
<p>When <code>delay</code> is larger than <code>2147483647</code> or less than <code>1</code>, the <code>delay</code>
will be set to <code>1</code>. Non-integer delays are truncated to an integer.</p>
<p>If <code>callback</code> is not a function, a <a href="errors.html#class-typeerror"><code>TypeError</code></a> will be thrown.</p>
<p>This method has a custom variant for promises that is available using
<a href="#timerspromisessettimeoutdelay-value-options"><code>timersPromises.setTimeout()</code></a>.</p>
</section><section><h3>Cancelling timers<span><a class="mark" href="#cancelling-timers" id="cancelling-timers">#</a></span><a aria-hidden="true" class="legacy" id="timers_cancelling_timers"></a></h3>
<p>The <a href="#setimmediatecallback-args"><code>setImmediate()</code></a>, <a href="#setintervalcallback-delay-args"><code>setInterval()</code></a>, and <a href="#settimeoutcallback-delay-args"><code>setTimeout()</code></a> methods
each return objects that represent the scheduled timers. These can be used to
cancel the timer and prevent it from triggering.</p>
<p>For the promisified variants of <a href="#setimmediatecallback-args"><code>setImmediate()</code></a> and <a href="#settimeoutcallback-delay-args"><code>setTimeout()</code></a>,
an <a href="globals.html#class-abortcontroller"><code>AbortController</code></a> may be used to cancel the timer. When canceled, the
returned Promises will be rejected with an <code>'AbortError'</code>.</p>
<p>For <code>setImmediate()</code>:</p>
<pre><code class="language-js"><span class="hljs-keyword">const</span> { <span class="hljs-attr">setImmediate</span>: setImmediatePromise } = <span class="hljs-built_in">require</span>(<span class="hljs-string">'node:timers/promises'</span>);

<span class="hljs-keyword">const</span> ac = <span class="hljs-keyword">new</span> <span class="hljs-title class_">AbortController</span>();
<span class="hljs-keyword">const</span> signal = ac.<span class="hljs-property">signal</span>;

<span class="hljs-title function_">setImmediatePromise</span>(<span class="hljs-string">'foobar'</span>, { signal })
  .<span class="hljs-title function_">then</span>(<span class="hljs-variable language_">console</span>.<span class="hljs-property">log</span>)
  .<span class="hljs-title function_">catch</span>(<span class="hljs-function">(<span class="hljs-params">err</span>) =></span> {
    <span class="hljs-keyword">if</span> (err.<span class="hljs-property">name</span> === <span class="hljs-string">'AbortError'</span>)
      <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(<span class="hljs-string">'The immediate was aborted'</span>);
  });

ac.<span class="hljs-title function_">abort</span>();</code></pre>
<p>For <code>setTimeout()</code>:</p>
<pre><code class="language-js"><span class="hljs-keyword">const</span> { <span class="hljs-attr">setTimeout</span>: setTimeoutPromise } = <span class="hljs-built_in">require</span>(<span class="hljs-string">'node:timers/promises'</span>);

<span class="hljs-keyword">const</span> ac = <span class="hljs-keyword">new</span> <span class="hljs-title class_">AbortController</span>();
<span class="hljs-keyword">const</span> signal = ac.<span class="hljs-property">signal</span>;

setTimeoutPromise(<span class="hljs-number">1000</span>, <span class="hljs-string">'foobar'</span>, { signal })
  .<span class="hljs-title function_">then</span>(<span class="hljs-variable language_">console</span>.<span class="hljs-property">log</span>)
  .<span class="hljs-title function_">catch</span>(<span class="hljs-function">(<span class="hljs-params">err</span>) =></span> {
    <span class="hljs-keyword">if</span> (err.<span class="hljs-property">name</span> === <span class="hljs-string">'AbortError'</span>)
      <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(<span class="hljs-string">'The timeout was aborted'</span>);
  });

ac.<span class="hljs-title function_">abort</span>();</code></pre>
<h4><code>clearImmediate(immediate)</code><span><a class="mark" href="#clearimmediateimmediate" id="clearimmediateimmediate">#</a></span><a aria-hidden="true" class="legacy" id="timers_clearimmediate_immediate"></a></h4>
<div class="api_metadata">
<span>Added in: v0.9.1</span>
</div>
<ul>
<li><code>immediate</code> <a href="timers.html#class-immediate" class="type">&#x3C;Immediate></a> An <code>Immediate</code> object as returned by
<a href="#setimmediatecallback-args"><code>setImmediate()</code></a>.</li>
</ul>
<p>Cancels an <code>Immediate</code> object created by <a href="#setimmediatecallback-args"><code>setImmediate()</code></a>.</p>
<h4><code>clearInterval(timeout)</code><span><a class="mark" href="#clearintervaltimeout" id="clearintervaltimeout">#</a></span><a aria-hidden="true" class="legacy" id="timers_clearinterval_timeout"></a></h4>
<div class="api_metadata">
<span>Added in: v0.0.1</span>
</div>
<ul>
<li><code>timeout</code> <a href="timers.html#class-timeout" class="type">&#x3C;Timeout></a> | <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#String_type" class="type">&#x3C;string></a> | <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Number_type" class="type">&#x3C;number></a> A <code>Timeout</code> object as returned by <a href="#setintervalcallback-delay-args"><code>setInterval()</code></a>
or the <a href="#timeoutsymboltoprimitive">primitive</a> of the <code>Timeout</code> object as a string or a number.</li>
</ul>
<p>Cancels a <code>Timeout</code> object created by <a href="#setintervalcallback-delay-args"><code>setInterval()</code></a>.</p>
<h4><code>clearTimeout(timeout)</code><span><a class="mark" href="#cleartimeouttimeout" id="cleartimeouttimeout">#</a></span><a aria-hidden="true" class="legacy" id="timers_cleartimeout_timeout"></a></h4>
<div class="api_metadata">
<span>Added in: v0.0.1</span>
</div>
<ul>
<li><code>timeout</code> <a href="timers.html#class-timeout" class="type">&#x3C;Timeout></a> | <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#String_type" class="type">&#x3C;string></a> | <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Number_type" class="type">&#x3C;number></a> A <code>Timeout</code> object as returned by <a href="#settimeoutcallback-delay-args"><code>setTimeout()</code></a>
or the <a href="#timeoutsymboltoprimitive">primitive</a> of the <code>Timeout</code> object as a string or a number.</li>
</ul>
<p>Cancels a <code>Timeout</code> object created by <a href="#settimeoutcallback-delay-args"><code>setTimeout()</code></a>.</p>
</section><section><h3>Timers Promises API<span><a class="mark" href="#timers-promises-api" id="timers-promises-api">#</a></span><a aria-hidden="true" class="legacy" id="timers_timers_promises_api"></a></h3>
<div class="api_metadata">
<details class="changelog"><summary>History</summary>
<table>
<tbody><tr><th>Version</th><th>Changes</th></tr>
<tr><td>v16.0.0</td>
<td><p>Graduated from experimental.</p></td></tr>
<tr><td>v15.0.0</td>
<td><p><span>Added in: v15.0.0</span></p></td></tr>
</tbody></table>
</details>
</div>
<p>The <code>timers/promises</code> API provides an alternative set of timer functions
that return <code>Promise</code> objects. The API is accessible via
<code>require('node:timers/promises')</code>.</p>

<pre class="with-13-chars"><input class="js-flavor-selector" type="checkbox" checked aria-label="Show modern ES modules syntax"><code class="language-js mjs"><span class="hljs-keyword">import</span> {
  <span class="hljs-built_in">setTimeout</span>,
  setImmediate,
  <span class="hljs-built_in">setInterval</span>,
} <span class="hljs-keyword">from</span> <span class="hljs-string">'timers/promises'</span>;</code><code class="language-js cjs"><span class="hljs-keyword">const</span> {
  <span class="hljs-built_in">setTimeout</span>,
  setImmediate,
  <span class="hljs-built_in">setInterval</span>,
} = <span class="hljs-built_in">require</span>(<span class="hljs-string">'node:timers/promises'</span>);</code></pre>
<h4><code>timersPromises.setTimeout([delay[, value[, options]]])</code><span><a class="mark" href="#timerspromisessettimeoutdelay-value-options" id="timerspromisessettimeoutdelay-value-options">#</a></span><a aria-hidden="true" class="legacy" id="timers_timerspromises_settimeout_delay_value_options"></a></h4>
<div class="api_metadata">
<span>Added in: v15.0.0</span>
</div>
<ul>
<li><code>delay</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Number_type" class="type">&#x3C;number></a> The number of milliseconds to wait before fulfilling the
promise. <strong>Default:</strong> <code>1</code>.</li>
<li><code>value</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Data_types" class="type">&#x3C;any></a> A value with which the promise is fulfilled.</li>
<li><code>options</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object" class="type">&#x3C;Object></a>
<ul>
<li><code>ref</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Boolean_type" class="type">&#x3C;boolean></a> Set to <code>false</code> to indicate that the scheduled <code>Timeout</code>
should not require the Node.js event loop to remain active.
<strong>Default:</strong> <code>true</code>.</li>
<li><code>signal</code> <a href="globals.html#class-abortsignal" class="type">&#x3C;AbortSignal></a> An optional <code>AbortSignal</code> that can be used to
cancel the scheduled <code>Timeout</code>.</li>
</ul>
</li>
</ul>

<pre class="with-13-chars"><input class="js-flavor-selector" type="checkbox" checked aria-label="Show modern ES modules syntax"><code class="language-js mjs"><span class="hljs-keyword">import</span> {
  <span class="hljs-built_in">setTimeout</span>,
} <span class="hljs-keyword">from</span> <span class="hljs-string">'timers/promises'</span>;

<span class="hljs-keyword">const</span> res = <span class="hljs-keyword">await</span> <span class="hljs-built_in">setTimeout</span>(<span class="hljs-number">100</span>, <span class="hljs-string">'result'</span>);

<span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(res);  <span class="hljs-comment">// Prints 'result'</span></code><code class="language-js cjs"><span class="hljs-keyword">const</span> {
  <span class="hljs-built_in">setTimeout</span>,
} = <span class="hljs-built_in">require</span>(<span class="hljs-string">'node:timers/promises'</span>);

<span class="hljs-built_in">setTimeout</span>(<span class="hljs-number">100</span>, <span class="hljs-string">'result'</span>).<span class="hljs-title function_">then</span>(<span class="hljs-function">(<span class="hljs-params">res</span>) =></span> {
  <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(res);  <span class="hljs-comment">// Prints 'result'</span>
});</code></pre>
<h4><code>timersPromises.setImmediate([value[, options]])</code><span><a class="mark" href="#timerspromisessetimmediatevalue-options" id="timerspromisessetimmediatevalue-options">#</a></span><a aria-hidden="true" class="legacy" id="timers_timerspromises_setimmediate_value_options"></a></h4>
<div class="api_metadata">
<span>Added in: v15.0.0</span>
</div>
<ul>
<li><code>value</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Data_types" class="type">&#x3C;any></a> A value with which the promise is fulfilled.</li>
<li><code>options</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object" class="type">&#x3C;Object></a>
<ul>
<li><code>ref</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Boolean_type" class="type">&#x3C;boolean></a> Set to <code>false</code> to indicate that the scheduled <code>Immediate</code>
should not require the Node.js event loop to remain active.
<strong>Default:</strong> <code>true</code>.</li>
<li><code>signal</code> <a href="globals.html#class-abortsignal" class="type">&#x3C;AbortSignal></a> An optional <code>AbortSignal</code> that can be used to
cancel the scheduled <code>Immediate</code>.</li>
</ul>
</li>
</ul>

<pre class="with-15-chars"><input class="js-flavor-selector" type="checkbox" checked aria-label="Show modern ES modules syntax"><code class="language-js mjs"><span class="hljs-keyword">import</span> {
  setImmediate,
} <span class="hljs-keyword">from</span> <span class="hljs-string">'timers/promises'</span>;

<span class="hljs-keyword">const</span> res = <span class="hljs-keyword">await</span> <span class="hljs-title function_">setImmediate</span>(<span class="hljs-string">'result'</span>);

<span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(res);  <span class="hljs-comment">// Prints 'result'</span></code><code class="language-js cjs"><span class="hljs-keyword">const</span> {
  setImmediate,
} = <span class="hljs-built_in">require</span>(<span class="hljs-string">'node:timers/promises'</span>);

<span class="hljs-title function_">setImmediate</span>(<span class="hljs-string">'result'</span>).<span class="hljs-title function_">then</span>(<span class="hljs-function">(<span class="hljs-params">res</span>) =></span> {
  <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(res);  <span class="hljs-comment">// Prints 'result'</span>
});</code></pre>
<h4><code>timersPromises.setInterval([delay[, value[, options]]])</code><span><a class="mark" href="#timerspromisessetintervaldelay-value-options" id="timerspromisessetintervaldelay-value-options">#</a></span><a aria-hidden="true" class="legacy" id="timers_timerspromises_setinterval_delay_value_options"></a></h4>
<div class="api_metadata">
<span>Added in: v15.9.0</span>
</div>
<p>Returns an async iterator that generates values in an interval of <code>delay</code> ms.</p>
<ul>
<li><code>delay</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Number_type" class="type">&#x3C;number></a> The number of milliseconds to wait between iterations.
<strong>Default:</strong> <code>1</code>.</li>
<li><code>value</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Data_types" class="type">&#x3C;any></a> A value with which the iterator returns.</li>
<li><code>options</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object" class="type">&#x3C;Object></a>
<ul>
<li><code>ref</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Boolean_type" class="type">&#x3C;boolean></a> Set to <code>false</code> to indicate that the scheduled <code>Timeout</code>
between iterations should not require the Node.js event loop to
remain active.
<strong>Default:</strong> <code>true</code>.</li>
<li><code>signal</code> <a href="globals.html#class-abortsignal" class="type">&#x3C;AbortSignal></a> An optional <code>AbortSignal</code> that can be used to
cancel the scheduled <code>Timeout</code> between operations.</li>
</ul>
</li>
</ul>

<pre class="with-14-chars"><input class="js-flavor-selector" type="checkbox" checked aria-label="Show modern ES modules syntax"><code class="language-js mjs"><span class="hljs-keyword">import</span> {
  <span class="hljs-built_in">setInterval</span>,
} <span class="hljs-keyword">from</span> <span class="hljs-string">'timers/promises'</span>;

<span class="hljs-keyword">const</span> interval = <span class="hljs-number">100</span>;
<span class="hljs-keyword">for</span> <span class="hljs-keyword">await</span> (<span class="hljs-keyword">const</span> startTime <span class="hljs-keyword">of</span> <span class="hljs-built_in">setInterval</span>(interval, <span class="hljs-title class_">Date</span>.<span class="hljs-title function_">now</span>())) {
  <span class="hljs-keyword">const</span> now = <span class="hljs-title class_">Date</span>.<span class="hljs-title function_">now</span>();
  <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(now);
  <span class="hljs-keyword">if</span> ((now - startTime) > <span class="hljs-number">1000</span>)
    <span class="hljs-keyword">break</span>;
}
<span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(<span class="hljs-title class_">Date</span>.<span class="hljs-title function_">now</span>());</code><code class="language-js cjs"><span class="hljs-keyword">const</span> {
  <span class="hljs-built_in">setInterval</span>,
} = <span class="hljs-built_in">require</span>(<span class="hljs-string">'node:timers/promises'</span>);
<span class="hljs-keyword">const</span> interval = <span class="hljs-number">100</span>;

(<span class="hljs-keyword">async</span> <span class="hljs-keyword">function</span>(<span class="hljs-params"></span>) {
  <span class="hljs-keyword">for</span> <span class="hljs-keyword">await</span> (<span class="hljs-keyword">const</span> startTime <span class="hljs-keyword">of</span> <span class="hljs-built_in">setInterval</span>(interval, <span class="hljs-title class_">Date</span>.<span class="hljs-title function_">now</span>())) {
    <span class="hljs-keyword">const</span> now = <span class="hljs-title class_">Date</span>.<span class="hljs-title function_">now</span>();
    <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(now);
    <span class="hljs-keyword">if</span> ((now - startTime) > <span class="hljs-number">1000</span>)
      <span class="hljs-keyword">break</span>;
  }
  <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(<span class="hljs-title class_">Date</span>.<span class="hljs-title function_">now</span>());
})();</code></pre>
<h4><code>timersPromises.scheduler.wait(delay[, options])</code><span><a class="mark" href="#timerspromisesschedulerwaitdelay-options" id="timerspromisesschedulerwaitdelay-options">#</a></span><a aria-hidden="true" class="legacy" id="timers_timerspromises_scheduler_wait_delay_options"></a></h4>
<div class="api_metadata">
<span>Added in: v17.3.0, v16.14.0</span>
</div>
<p></p><div class="api_stability api_stability_1"><a href="documentation.html#stability-index">Stability: 1</a> - Experimental</div><p></p>
<ul>
<li><code>delay</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Number_type" class="type">&#x3C;number></a> The number of milliseconds to wait before resolving the
promise.</li>
<li><code>options</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object" class="type">&#x3C;Object></a>
<ul>
<li><code>signal</code> <a href="globals.html#class-abortsignal" class="type">&#x3C;AbortSignal></a> An optional <code>AbortSignal</code> that can be used to
cancel waiting.</li>
</ul>
</li>
<li>Returns: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" class="type">&#x3C;Promise></a></li>
</ul>
<p>An experimental API defined by the <a href="https://github.com/WICG/scheduling-apis">Scheduling APIs</a> draft specification
being developed as a standard Web Platform API.</p>
<p>Calling <code>timersPromises.scheduler.wait(delay, options)</code> is roughly equivalent
to calling <code>timersPromises.setTimeout(delay, undefined, options)</code> except that
the <code>ref</code> option is not supported.</p>
<pre><code class="language-js mjs"><span class="hljs-keyword">import</span> { scheduler } <span class="hljs-keyword">from</span> <span class="hljs-string">'node:timers/promises'</span>;

<span class="hljs-keyword">await</span> scheduler.<span class="hljs-title function_">wait</span>(<span class="hljs-number">1000</span>); <span class="hljs-comment">// Wait one second before continuing</span></code></pre>
<h4><code>timersPromises.scheduler.yield()</code><span><a class="mark" href="#timerspromisesscheduleryield" id="timerspromisesscheduleryield">#</a></span><a aria-hidden="true" class="legacy" id="timers_timerspromises_scheduler_yield"></a></h4>
<div class="api_metadata">
<span>Added in: v17.3.0, v16.14.0</span>
</div>
<p></p><div class="api_stability api_stability_1"><a href="documentation.html#stability-index">Stability: 1</a> - Experimental</div><p></p>
<ul>
<li>Returns: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" class="type">&#x3C;Promise></a></li>
</ul>
<p>An experimental API defined by the <a href="https://github.com/WICG/scheduling-apis">Scheduling APIs</a> draft specification
being developed as a standard Web Platform API.</p>
<p>Calling <code>timersPromises.scheduler.yield()</code> is equivalent to calling
<code>timersPromises.setImmediate()</code> with no arguments.</p></section>
        <!-- API END -->
      </div>
    </div>
  </div>
</body>
</html>
